*** src/backend/utils/adt/numeric.c.old	Fri Mar 30 14:39:38 2001
--- src/backend/utils/adt/numeric.c	Fri Mar 30 14:42:23 2001
***************
*** 3109,3124 ****
  	init_var(&tmp);
  
  	/* ----------
! 	 * We do it by fiddling around with global_rscale and truncating
! 	 * the result of the division.
  	 * ----------
  	 */
  	save_global_rscale = global_rscale;
  	global_rscale = var2->rscale + 2;
  
  	div_var(var1, var2, &tmp);
  	tmp.rscale = var2->rscale;
- 	tmp.ndigits = MAX(0, MIN(tmp.ndigits, tmp.weight + tmp.rscale + 1));
  
  	global_rscale = var2->rscale;
  	mul_var(var2, &tmp, &tmp);
--- 3109,3127 ----
  	init_var(&tmp);
  
  	/* ----------
!          * We do this using the equation
!          *              mod(x,y) = x - trunc(x/y)*y
!          * We fiddle a bit with global_rscale to control result precision.
  	 * ----------
  	 */
  	save_global_rscale = global_rscale;
  	global_rscale = var2->rscale + 2;
  
  	div_var(var1, var2, &tmp);
+ 
+         /* do trunc() by forgetting digits to the right of the decimal point */
+         tmp.ndigits = MAX(0, MIN(tmp.ndigits, tmp.weight + 1));
  	tmp.rscale = var2->rscale;
  
  	global_rscale = var2->rscale;
  	mul_var(var2, &tmp, &tmp);
